#include "CriticalPath.h"

Stack stack, TopoSortResult;
int Ve[MAX_VERTEX_NUM];		  // An array of the earliest events to occur
int Vl[MAX_VERTEX_NUM];		  // Event latest occurrence time array

int main(int argc, char* argv[])
{	
	GraphList GraphList;
	
	//
	// Initialize the figure
	//
	InitGraph(&GraphList);
	
	//
	// Call the InitStack function to initialize the stack
	//
	InitStack(&stack);
	InitStack(&TopoSortResult);

	//
	// The critical path
	//
	CriticalPath(&GraphList);
	
	
	//
	// output result
	//
	OutputResult(&GraphList);
	
	
	//
	// Destruction of figure
	//
	DeleteGraph(&GraphList);
	
	return 0;
}

/*
function:
	Find the degree of entry of all vertices in the graph

parameter:
	pGraphList -- Figure pointer
	
*/
void FindInDegree(GraphList *pGraphList)
{
			
	//
	// TODO: Add the code here
	//	
				
}

/*
function:
	Topological sort.Push the sorting result (vertex index) into the stack TopoSortResult
	And computes the array of the earliest occurrence of the event

parameter:
	pGraphList -- Figure pointer
	
returned value:
	Returns 1 if the sort succeeds
	Returns 1 if the sort fails	
*/
int TopologicalSort(GraphList* pGraphList)
{	
	FindInDegree(pGraphList); // Find the degree of entry of all vertices in the graph
		
	//
	// TODO: Add the code here
	//
		
	return 0;	
}

/*
function:
	The critical path

parameter:
	pGraphList -- Figure pointer
		
returned value:
	Returns 1 if critical path is calculated successfully
	Returns 0 if critical path calculation fails		
*/
int CriticalPath(GraphList* pGraphList)
{
	EdgeNode* pEdgeNode;			  // Edge (arc) node pointer
	int i, k;						  // The cursor
	int ee, el;						  // Temporary variable

	TopologicalSort(pGraphList); 	  // Topological sort
	
	//
	// Initializes an array of the latest occurrence times of events
	//
	for (i = 0; i < pGraphList->length; i++)	
	{
		Vl[i] = Ve[pGraphList->length - 1]; 
	}
	
	//
	// TODO: Add the code here
	//
	
	return 0;							
}							

/*
function:
	Initializes the graph's adjacency list with the given data

parameter:
	pGraphList -- Figure pointer
*/
typedef struct Arc
{
		int Weight;					// The weight.		
		int VexIndex;				// The sequence of vertices adjacent to this vertex.
		const char* Name;			// Side (arc) activity name
}Arc;
typedef struct VertexArrayEntry 
{
	const char* Name;				// Name of the vertices.NULL indicates the end of the vertex sequence.
	Arc ArcArray[MAX_VERTEX_NUM];	// Edge array.
}VertexArrayEntry;
const VertexArrayEntry VertexArray[] = 
{
	{ "V1", { {4, 2, "a2"}, {6, 1, "a1"}, {5, 3, "a3"} } },
	{ "V2", { {1, 4, "a4"} } 				  		     },
	{ "V3", { {1, 4, "a5"} } 				 		     },
	{ "V4", { {2, 5, "a6"} }                             },
	{ "V5", { {9, 6, "a7"}, {7, 7, "a8"} }               },
	{ "V6", { {4, 7, "a9"} }                             },
	{ "V7", { {2, 8, "a10"}}                             },
	{ "V8", { {4, 8, "a11"}}                             },
	{ "V9", {  }                                         },	
	{ NULL 					                             }	// End mark
};

/*
function:
	Initialize the figure

parameter:
	pGraphList -- Figure pointer
*/
void InitGraph(GraphList* pGraphList)
{
	int i, j;					// The cursor
	EdgeNode** pEdgeNodePtr;	// Pointer to a pointer to an edge (arc) node pointer
	
	//
	// Reset the length of the data in the graph
	//
	pGraphList->length = 0;
	
	//
	// Initializes the graph's adjacency list with the given data
	//
	for (i=0; i<MAX_VERTEX_NUM; i++)
	{
		// Name of the vertices.NULL indicates the end of the vertex sequence.
		if (NULL == VertexArray[i].Name) 
		{
			break;
		}
			
		pGraphList->vexlist[i].name = VertexArray[i].Name;
		
		// Makes the pointer point to the first edge of 
		// the vertex array (where the pointer was initialized)
		pEdgeNodePtr = &pGraphList->vexlist[i].firstarc; 
		for (j=0; j<MAX_VERTEX_NUM; j++)
		{
			if (NULL == VertexArray[i].ArcArray[j].Name)
			{
				*pEdgeNodePtr = NULL;
				break;
			}
			
			*pEdgeNodePtr = (EdgeNode*)malloc(sizeof(EdgeNode));
			(*pEdgeNodePtr)->vertex = VertexArray[i].ArcArray[j].VexIndex;
			(*pEdgeNodePtr)->weight = VertexArray[i].ArcArray[j].Weight;
			(*pEdgeNodePtr)->name = VertexArray[i].ArcArray[j].Name;
			(*pEdgeNodePtr)->isCritical = FALSE;
			pEdgeNodePtr = &(*pEdgeNodePtr)->nextedge;
		}
		
		pGraphList->length++;
	}
}

/*
function:
	Destruction of figure

parameter:
	pGraphList -- Figure pointer
*/
void DeleteGraph(GraphList* pGraphList)
{
	int i;
	EdgeNode* pEdgeNode;
	
	for (i=0; i<pGraphList->length; i++)
	{
		while (pGraphList->vexlist[i].firstarc != NULL)
		{
			pEdgeNode = pGraphList->vexlist[i].firstarc;
			pGraphList->vexlist[i].firstarc = pEdgeNode->nextedge;
			free(pEdgeNode);
		}
	}
	
	pGraphList->length = 0;
}

/*
function:
	output result

parameter:
	nothing
*/
void OutputResult(GraphList* pGraphList)
{
	EdgeNode* pEdgeNode;	// Edge (arc) node pointer
	int i, k;				// The subscript
	int ee, el;				// Temporary variable
	
	printf("VertexSeq:\t\t\t\t\t\t\t\t\t");
	for (i = 0; i < pGraphList->length; i++)
	{
		printf("\t%s", pGraphList->vexlist[i].name);
	}
	printf("\n");
	
	printf("An array of the earliest events to occur Ve:");
	for (i = 0; i < pGraphList->length; i++)
	{
		printf("\t%d ", Ve[i]);
	}
	printf("\n");
	
	printf("Event latest occurrentce time array Vl:\t\t");
	for (i = 0; i < pGraphList->length; i++)
	{
		printf("\t%d ", Vl[i]);
	}
	printf("\n");
	
	printf("AdjacencyList:\n");
	printf("Vertex   (VertexSubscript ActivityName Weight)...\n");
	for (i = 0; i < pGraphList->length; i++)
	{
		printf("%s", pGraphList->vexlist[i].name);
		for (pEdgeNode = pGraphList->vexlist[i].firstarc; pEdgeNode!=NULL; 
				pEdgeNode = pEdgeNode->nextedge)
		{
			//
			// Save the vertex index that the edge (arc) node pointer points to in k
			//

			k = pEdgeNode->vertex;
	
			//
			// ee saves the value of Ve[i],le saves the value of Vl[k] 
			// and subtracts the weight corresponding to the edge node pointer
			//

			ee = Ve[i];
			el = Vl[k] - pEdgeNode->weight;

			if (ee == el)
			{
				printf(" -> (%2d [%s=%d])", pEdgeNode->vertex, pEdgeNode->name, pEdgeNode->weight);
				pEdgeNode->isCritical = TRUE; 
			}
			else
			{
				printf(" -> (%2d  %s=%d )", pEdgeNode->vertex, pEdgeNode->name, pEdgeNode->weight);
			}	
		}
		printf(" -> NULL \n");

	}	
}
